#================= MODELING ================================

oz_mute_land_for = $(shell echo -0.5*$(dz)*$(rec_nz) | bc -l)
oz_mute_obn_for  = $(shell echo -0.5*$(dz)*$(rec_nz) | bc -l)

# execute elastic propagation from source location
land1_for: ${B}/Elas2d.x ${D}/lambda2d_land.H ${D}/mu2d_land.H ${D}/rho2d_land.H ${P}/mod2d_for.P ${D}/recs2d_land_for.H
	${B}/Elas2d.x par=${P}/mod2d_for.P \
	proptype=${SRC} isrc_type=${ST} splitdisp=0 surf_type=0 nt=${nt_for} dt=${dt_for} damper=${damper_land} xlambda=${xlambda_land} \
	lambda=${D}/lambda2d_land.H mu=${D}/mu2d_land.H rho=${D}/rho2d_land.H recs=${D}/recs2d_land_for.H \
	rec_P=${D}/${ST}Pr_land.H rec_S=${D}/${ST}Sr_land.H rec_ux=${D}/${ST}uxr_land.H rec_uz=${D}/${ST}uzr_land.H
	echo "d1=${dz}" >> ${D}/${ST}Pr_land.H
	echo "d1=${dz}" >> ${D}/${ST}Sr_land.H
	echo "d1=${dz}" >> ${D}/${ST}uxr_land.H
	echo "d1=${dz}" >> ${D}/${ST}uzr_land.H
	echo "o1=${oz_mute_land_for}" >> ${D}/${ST}Pr_land.H
	echo "o1=${oz_mute_land_for}" >> ${D}/${ST}Sr_land.H
	echo "o1=${oz_mute_land_for}" >> ${D}/${ST}uxr_land.H
	echo "o1=${oz_mute_land_for}" >> ${D}/${ST}uzr_land.H
	#snap_P=${D}/${ST}P_land.H     snap_S=${D}/${ST}S_land.H \
	snap_ux=${D}/${ST}ux_land.H   snap_uz=${D}/${ST}uz_land.H \


# execute acoustic propagation from source location (vs=0)
obn1_for: ${B}/Elas2d.x ${D}/lambda2d_obn.H ${D}/mu2d_obn.H ${D}/rho2d_obn.H ${P}/mod2d_for.P ${D}/recs2d_obn_for.H
	${B}/Elas2d.x par=${P}/mod2d_for.P \
	proptype=${SRC} isrc_type=${ST} splitdisp=0 surf_type=1 nt=${nt_for} dt=${dt_for} damper=${damper_obn} xlambda=${xlambda_obn} \
	lambda=${D}/lambda2d_obn.H mu=${D}/mu2d_obn.H rho=${D}/rho2d_obn.H recs=${D}/recs2d_obn_for.H \
	rec_P=${D}/${ST}Pr_obn.H rec_S=${D}/${ST}Sr_obn.H rec_ux=${D}/${ST}uxr_obn.H rec_uz=${D}/${ST}uzr_obn.H
	echo "d1=${dz}" >> ${D}/${ST}Pr_obn.H
	echo "d1=${dz}" >> ${D}/${ST}Sr_obn.H
	echo "d1=${dz}" >> ${D}/${ST}uxr_obn.H
	echo "d1=${dz}" >> ${D}/${ST}uzr_obn.H
	echo "o1=${oz_mute_obn_for}" >> ${D}/${ST}Pr_obn.H
	echo "o1=${oz_mute_obn_for}" >> ${D}/${ST}Sr_obn.H
	echo "o1=${oz_mute_obn_for}" >> ${D}/${ST}uxr_obn.H
	echo "o1=${oz_mute_obn_for}" >> ${D}/${ST}uzr_obn.H
	#snap_P=${D}/${ST}P_obn.H    snap_S=${D}/${ST}S_obn.H \
	snap_ux=${D}/${ST}ux_obn.H	snap_uz=${D}/${ST}uz_obn.H \

synthetics:
	make land1_for source=0
	make obn1_for source=0
