#============== MODEL BUILDING FOR FORWARD MODELING ===================================

# receiver locations for land data forward modeling
${D}/recs2d_land_for.H:  ${B}/create_recs.x ${P}/mod2d_for.P
	${B}/create_recs.x >$@ par=${P}/mod2d_for.P rec_nx=${rec_nx_land_for} rec_fx=${rec_fx_land_for} rec_jx=${rec_jx_land_for}

# receiver locations for obn data forward modeling
${D}/recs2d_obn_for.H:  ${B}/create_recs.x ${P}/mod2d_for.P
	${B}/create_recs.x >$@ par=${P}/mod2d_for.P rec_nx=${rec_nx_obn_for} rec_fx=${rec_fx_obn_for} rec_jx=${rec_jx_obn_for}


# 3 layers on land
${D}/rho2d_land.H: 
	Vel n1=${nx_for} n2=${nz_for} n3=1 o1=0 o2=0 o3=0 d1=${dx_for} d2=${dz_for} d3=1 vc=${rho0_land} \
	z1=${h1_land} vr1=${rho1_land} const1=1 \
	z2=${h2_land} vr2=${rho2_land} const2=1 > ${D}/tmprho.H
	Math file1=${D}/tmprho.H exp='1./file1' > $@
	Rm ${D}/tmprho.H

${D}/vp2d_land.H:
	Vel n1=${nx_for} n2=${nz_for} n3=1 o1=0 o2=0 o3=0 d1=${dx_for} d2=${dz_for} d3=1 vc=${vp0_land} \
	z1=${h1_land} vr1=${vp1_land} const1=1 \
	z2=${h2_land} vr2=${vp2_land} const2=1 > $@

${D}/vs2d_land.H:
	Vel n1=${nx_for} n2=${nz_for} n3=1 o1=0 o2=0 o3=0 d1=${dx_for} d2=${dz_for} d3=1 vc=${vs0_land} \
	z1=${h1_land} vr1=${vs1_land} const1=1 \
	z2=${h2_land} vr2=${vs2_land} const2=1 > $@

${D}/mu2d_land.H: ${D}/rho2d_land.H ${D}/vs2d_land.H
	Math file1=${D}/rho2d_land.H file2=${D}/vs2d_land.H exp='file2^2/file1' > $@

${D}/lambda2d_land.H: ${D}/rho2d_land.H ${D}/vp2d_land.H ${D}/mu2d_land.H
	Math file1=${D}/rho2d_land.H file2=${D}/vp2d_land.H file3=${D}/mu2d_land.H exp='file2^2/file1-2*file3' > $@


# water layer overlying two sediments
${D}/rho2d_obn.H: 
	Vel n1=${nx_for} n2=${nz_for} n3=1 o1=0 o2=0 o3=0 d1=${dx_for} d2=${dz_for} d3=1 vc=${rho0_obn} \
	z1=${h1_obn} vr1=${rho1_obn} const1=1 \
	z2=${h2_obn} vr2=${rho2_obn} const2=1 > ${D}/tmprho.H
	Math file1=${D}/tmprho.H exp='1./file1' > $@
	Rm ${D}/tmprho.H

${D}/vp2d_obn.H:
	Vel n1=${nx_for} n2=${nz_for} n3=1 o1=0 o2=0 o3=0 d1=${dx_for} d2=${dz_for} d3=1 vc=${vp0_obn} \
	z1=${h1_obn} vr1=${vp1_obn} const1=1 \
	z2=${h2_obn} vr2=${vp2_obn} const2=1 > $@

${D}/vs2d_obn.H:
	Vel n1=${nx_for} n2=${nz_for} n3=1 o1=0 o2=0 o3=0 d1=${dx_for} d2=${dz_for} d3=1 vc=${vs0_obn} > $@

${D}/mu2d_obn.H: ${D}/rho2d_obn.H ${D}/vs2d_obn.H
	Math file1=${D}/rho2d_obn.H file2=${D}/vs2d_obn.H exp='file2^2/file1' > $@

${D}/lambda2d_obn.H: ${D}/rho2d_obn.H ${D}/vp2d_obn.H ${D}/mu2d_obn.H
	Math file1=${D}/rho2d_obn.H file2=${D}/vp2d_obn.H file3=${D}/mu2d_obn.H exp='file2^2/file1-2*file3' > $@

vmodels_for:
	make ${D}/recs2d_land_for.H ${D}/recs2d_obn_for.H
	make ${D}/vp2d_land.H ${D}/vs2d_land.H ${D}/rho2d_land.H ${D}/mu2d_land.H ${D}/lambda2d_land.H
	make ${D}/vp2d_obn.H ${D}/vs2d_obn.H ${D}/rho2d_obn.H ${D}/mu2d_obn.H ${D}/lambda2d_obn.H
