# ============================ FIGURES =======================================================
#==============================================================================================
TITLESZ = 18
LABELSZ = 10
GT      = Grey             label2="X (m)" label1="time (s)" title=" " titlesz=${TITLESZ} labelsz=${LABELSZ}
GTLAND1 = Grey clip=0.0003 label2="X (m)" label1="time (s)" title=" " titlesz=${TITLESZ} labelsz=${LABELSZ}
GTLAND2 = Grey clip=0.0001 label2="X (m)" label1="time (s)" title=" " titlesz=${TITLESZ} labelsz=${LABELSZ}
GTLAND2U= Grey             label2="X (m)" label1="time (s)" title=" " titlesz=${TITLESZ} labelsz=${LABELSZ}
GTMEDIUM= Grey newclip=1   label2="X (m)" label1="Z (m)"    title=" " titlesz=${TITLESZ} labelsz=${LABELSZ}
J1 = 2
J2 = 4
J1BIG = 20
J2BIG = 100
#===============================================

# up-down sketch
${R}/up-down-sketch.pdf: ${R}/NR/up-down-sketch.pdf
	cp $< $@

# solution space sketch
${R}/PS-sol-space.pdf: ${R}/NR/PS-sol-space.pdf
	cp $< $@

# src rcvr locations sketch
${R}/src-rec-locations.pdf: ${R}/NR/src-rec-locations.pdf
	cp $< $@

# land 1 medium parameters
${R}/vp-land: ${D}/vp2d_land.H
	Window3d < $< j1=${J1BIG} j2=${J2BIG} | ${GTMEDIUM} barlabel="km/s" out=$@.v > ${dn}
	vp_annotate < $@.v text=${R}/NR/vp-land.txt batch=y > $@-a.v

# obn medium parameters
${R}/vp-obn: ${D}/vp2d_obn.H
	Window3d < $< j1=${J1BIG} j2=${J2BIG} | ${GTMEDIUM} barlabel="km/s" out=$@.v > ${dn}
	vp_annotate < $@.v text=${R}/NR/vp-obn.txt batch=y > $@-a.v

# land data virtual source functions
${R}/su1-0: ${D}/uxs_land.H
	Window3d < $< j1=${J1} j2=${J2} | Transp | ${GT} out=$@.v > ${dn}

${R}/su1-1: ${D}/uzs_land.H
	Window3d < $< j1=${J1} j2=${J2} | Transp | ${GT} out=$@.v > ${dn}

# land data displacements: observed, inverted, inverted slow, inverted fast
${R}/lu1-0: ${D}/uxr_land_obs.H
	Window3d < $< j1=${J1} j2=${J2} | Reverse which=2 opt=ignore | Transp | ${GT} out=$@.v > ${dn}
	ln $@.v $@L.v

${R}/lu1-1: ${D}/uzr_land_obs.H
	Window3d < $< j1=${J1} j2=${J2} | Reverse which=2 opt=ignore | Transp | ${GT} out=$@.v > ${dn}
	ln $@.v $@L.v

${R}/lu1-2: ${D}/uxr_land_inv.H
	Window3d < $< j1=${J1} j2=${J2} | Reverse which=2 opt=ignore | Transp | ${GT} out=$@.v > ${dn}

${R}/lu1-3: ${D}/uzr_land_inv.H
	Window3d < $< j1=${J1} j2=${J2} | Reverse which=2 opt=ignore | Transp | ${GT} out=$@.v > ${dn}

${R}/lu1-4: ${D}/uxr_land_inv_slow.H
	Window3d < $< j1=${J1} j2=${J2} | Reverse which=2 opt=ignore | Transp | ${GT} out=$@.v > ${dn}

${R}/lu1-5: ${D}/uzr_land_inv_slow.H
	Window3d < $< j1=${J1} j2=${J2} | Reverse which=2 opt=ignore | Transp | ${GT} out=$@.v > ${dn}

${R}/lu1-6: ${D}/uxr_land_inv_fast.H
	Window3d < $< j1=${J1} j2=${J2} | Reverse which=2 opt=ignore | Transp | ${GT} out=$@.v > ${dn}

${R}/lu1-7: ${D}/uzr_land_inv_fast.H
	Window3d < $< j1=${J1} j2=${J2} | Reverse which=2 opt=ignore | Transp | ${GT} out=$@.v > ${dn}


# land data P and S: observed, inverted, inverted slow, inverted fast
${R}/lp1-0: ${D}/Pr_land_obs.H
	Window3d < $< j1=${J1} j2=${J2} | Reverse which=2 opt=ignore | Transp | ${GTLAND1} out=$@.v > ${dn}
	ln $@.v $@L.v

${R}/lp1-1: ${D}/Sr_land_obs.H
	Window3d < $< j1=${J1} j2=${J2} | Reverse which=2 opt=ignore | Transp | ${GTLAND1} out=$@.v > ${dn}
	ln $@.v $@L.v

${R}/lp1-2: ${D}/Pr_land_inv.H
	Window3d < $< j1=${J1} j2=${J2} | Reverse which=2 opt=ignore | Transp | ${GTLAND1} out=$@.v > ${dn}

${R}/lp1-3: ${D}/Sr_land_inv.H
	Window3d < $< j1=${J1} j2=${J2} | Reverse which=2 opt=ignore | Transp | ${GTLAND1} out=$@.v > ${dn}

${R}/lp1-4: ${D}/Pr_land_inv_slow.H
	Window3d < $< j1=${J1} j2=${J2} | Reverse which=2 opt=ignore | Transp | ${GTLAND1} out=$@.v > ${dn}

${R}/lp1-5: ${D}/Sr_land_inv_slow.H
	Window3d < $< j1=${J1} j2=${J2} | Reverse which=2 opt=ignore | Transp | ${GTLAND1} out=$@.v > ${dn}

${R}/lp1-6: ${D}/Pr_land_inv_fast.H
	Window3d < $< j1=${J1} j2=${J2} | Reverse which=2 opt=ignore | Transp | ${GTLAND1} out=$@.v > ${dn}

${R}/lp1-7: ${D}/Sr_land_inv_fast.H
	Window3d < $< j1=${J1} j2=${J2} | Reverse which=2 opt=ignore | Transp | ${GTLAND1} out=$@.v > ${dn}

${R}/lp1-8: ${D}/Pr_land_obs.H ${D}/Sr_land_obs.H
	Add scale=1,1 ${D}/Pr_land_obs.H ${D}/Sr_land_obs.H > ${D}/P_and_S_land_obs.H
	Window3d < ${D}/P_and_S_land_obs.H j1=${J1} j2=${J2} | Reverse which=2 opt=ignore | Transp | ${GTLAND1} out=$@.v > ${dn}
	ln $@.v $@L.v

# silly land data displacements: observed, inverted, inverted slow, inverted fast
${R}/lu2-0: ${D}/uxr_land2_obs.H
	Window3d < $< j1=${J1} j2=${J2} | Reverse which=2 opt=ignore | Transp | ${GT} out=$@.v > ${dn}

${R}/lu2-1: ${D}/uzr_land2_obs.H
	Window3d < $< j1=${J1} j2=${J2} | Reverse which=2 opt=ignore | Transp | ${GT} out=$@.v > ${dn}

${R}/lu2-2: ${D}/uxr_land2_inv.H
	Window3d < $< j1=${J1} j2=${J2} | Reverse which=2 opt=ignore | Transp | ${GT} out=$@.v > ${dn}

${R}/lu2-3: ${D}/uzr_land2_inv.H
	Window3d < $< j1=${J1} j2=${J2} | Reverse which=2 opt=ignore | Transp | ${GT} out=$@.v > ${dn}

${R}/lu2-4: ${D}/uxr_land2_inv_slow.H
	Window3d < $< j1=${J1} j2=${J2} | Reverse which=2 opt=ignore | Transp | ${GT} out=$@.v > ${dn}

${R}/lu2-5: ${D}/uzr_land2_inv_slow.H
	Window3d < $< j1=${J1} j2=${J2} | Reverse which=2 opt=ignore | Transp | ${GT} out=$@.v > ${dn}

${R}/lu2-6: ${D}/uxr_land2_inv_fast.H
	Window3d < $< j1=${J1} j2=${J2} | Reverse which=2 opt=ignore | Transp | ${GT} out=$@.v > ${dn}

${R}/lu2-7: ${D}/uzr_land2_inv_fast.H
	Window3d < $< j1=${J1} j2=${J2} | Reverse which=2 opt=ignore | Transp | ${GT} out=$@.v > ${dn}


# silly land2 data P and S: observed, inverted, inverted slow, inverted fast
${R}/lp2-0: ${D}/Pr_land2_obs.H
	Window3d < $< j1=${J1} j2=${J2} | Reverse which=2 opt=ignore | Transp | ${GTLAND2} out=$@.v > ${dn}
	ln $@.v $@L.v

${R}/lp2-1: ${D}/Sr_land2_obs.H
	Window3d < $< j1=${J1} j2=${J2} | Reverse which=2 opt=ignore | Transp | ${GTLAND2} out=$@.v > ${dn}
	ln $@.v $@L.v

${R}/lp2-2: ${D}/Pr_land2_inv.H
	Window3d < $< j1=${J1} j2=${J2} | Reverse which=2 opt=ignore | Transp | ${GTLAND2} out=$@.v > ${dn}

${R}/lp2-3: ${D}/Sr_land2_inv.H
	Window3d < $< j1=${J1} j2=${J2} | Reverse which=2 opt=ignore | Transp | ${GTLAND2} out=$@.v > ${dn}

${R}/lp2-4: ${D}/Pr_land2_inv_slow.H
	Window3d < $< j1=${J1} j2=${J2} | Reverse which=2 opt=ignore | Transp | ${GTLAND2} out=$@.v > ${dn}

${R}/lp2-5: ${D}/Sr_land2_inv_slow.H
	Window3d < $< j1=${J1} j2=${J2} | Reverse which=2 opt=ignore | Transp | ${GTLAND2} out=$@.v > ${dn}

${R}/lp2-6: ${D}/Pr_land2_inv_fast.H
	Window3d < $< j1=${J1} j2=${J2} | Reverse which=2 opt=ignore | Transp | ${GTLAND2} out=$@.v > ${dn}

${R}/lp2-7: ${D}/Sr_land2_inv_fast.H
	Window3d < $< j1=${J1} j2=${J2} | Reverse which=2 opt=ignore | Transp | ${GTLAND2} out=$@.v > ${dn}

${R}/lp2-8: ${D}/Pr_land2_obs.H ${D}/Sr_land2_obs.H
	Add scale=1,1 ${D}/Pr_land2_obs.H ${D}/Sr_land2_obs.H > ${D}/P_and_S_land2_obs.H
	Window3d < ${D}/P_and_S_land2_obs.H j1=${J1} j2=${J2} | Reverse which=2 opt=ignore | Transp | ${GTLAND2} out=$@.v > ${dn}
	ln $@.v $@L.v

# obn data displacements: observed, inverted
${R}/ou1-0: ${D}/uxr_obn_obs.H
	Window3d < $< j1=${J1} j2=${J2} | Reverse which=2 opt=ignore | Transp | ${GT} out=$@.v > ${dn}
	vp_annotate < $@.v text=${R}/NR/ou1-0.txt batch=y > $@-a.v

${R}/ou1-1: ${D}/uzr_obn_obs.H
	Window3d < $< j1=${J1} j2=${J2} | Reverse which=2 opt=ignore | Transp | ${GT} out=$@.v > ${dn}

${R}/ou1-2: ${D}/uxr_obn_inv.H
	Window3d < $< j1=${J1} j2=${J2} | Reverse which=2 opt=ignore | Transp | ${GT} out=$@.v > ${dn}

${R}/ou1-3: ${D}/uzr_obn_inv.H
	Window3d < $< j1=${J1} j2=${J2} | Reverse which=2 opt=ignore | Transp | ${GT} out=$@.v > ${dn}

# obn data P and S: observed, inverted
${R}/op1-0: ${D}/Pr_obn_obs.H
	Window3d < $< j1=${J1} j2=${J2} | Reverse which=2 opt=ignore | Transp | ${GT} out=$@.v > ${dn}
	vp_annotate < $@.v text=${R}/NR/ou1-0.txt batch=y > $@-a.v

${R}/op1-1: ${D}/Sr_obn_obs.H
	Window3d < $< j1=${J1} j2=${J2} | Reverse which=2 opt=ignore | Transp | ${GT} out=$@.v > ${dn}

${R}/op1-2: ${D}/Pr_obn_inv.H
	Window3d < $< j1=${J1} j2=${J2} | Reverse which=2 opt=ignore | Transp | ${GT} out=$@.v > ${dn}

${R}/op1-3: ${D}/Sr_obn_inv.H
	Window3d < $< j1=${J1} j2=${J2} | Reverse which=2 opt=ignore | Transp | ${GT} out=$@.v > ${dn}

NR:
	make ${R}/up-down-sketch.pdf ${R}/PS-sol-space.pdf ${R}/src-rec-locations.pdf

ER:
	make ${R}/vp-land ${R}/vp-obn
	make ${R}/su1-0 ${R}/su1-1
	make ${R}/lu1-0 ${R}/lu1-1 ${R}/lu1-2 ${R}/lu1-3 ${R}/lu1-4 ${R}/lu1-5 ${R}/lu1-6 ${R}/lu1-7
	make ${R}/lp1-0 ${R}/lp1-1 ${R}/lp1-2 ${R}/lp1-3 ${R}/lp1-4 ${R}/lp1-5 ${R}/lp1-6 ${R}/lp1-7 ${R}/lp1-8
	make ${R}/lu2-0 ${R}/lu2-1 ${R}/lu2-2 ${R}/lu2-3 ${R}/lu2-4 ${R}/lu2-5 ${R}/lu2-6 ${R}/lu2-7
	make ${R}/lp2-0 ${R}/lp2-1 ${R}/lp2-2 ${R}/lp2-3 ${R}/lp2-4 ${R}/lp2-5 ${R}/lp2-6 ${R}/lp2-7 ${R}/lp2-8
	make ${R}/ou1-0 ${R}/ou1-1 ${R}/ou1-2 ${R}/ou1-3
	make ${R}/op1-0 ${R}/op1-1 ${R}/op1-2 ${R}/op1-3
	make ${R}/vp-land-a.pdf ${R}/vp-obn-a.pdf
	make ${R}/su1-0.pdf ${R}/su1-1.pdf
	make ${R}/lu1-0.pdf ${R}/lu1-1.pdf ${R}/lu1-2.pdf ${R}/lu1-3.pdf ${R}/lu1-4.pdf ${R}/lu1-5.pdf ${R}/lu1-6.pdf ${R}/lu1-7.pdf
	make ${R}/lp1-0.pdf ${R}/lp1-1.pdf ${R}/lp1-2.pdf ${R}/lp1-3.pdf ${R}/lp1-4.pdf ${R}/lp1-5.pdf ${R}/lp1-6.pdf ${R}/lp1-7.pdf ${R}/lp1-8.pdf
	make ${R}/lu2-0.pdf ${R}/lu2-1.pdf ${R}/lu2-2.pdf ${R}/lu2-3.pdf ${R}/lu2-4.pdf ${R}/lu2-5.pdf ${R}/lu2-6.pdf ${R}/lu2-7.pdf
	make ${R}/lp2-0.pdf ${R}/lp2-1.pdf ${R}/lp2-2.pdf ${R}/lp2-3.pdf ${R}/lp2-4.pdf ${R}/lp2-5.pdf ${R}/lp2-6.pdf ${R}/lp2-7.pdf ${R}/lp2-8.pdf
	make ${R}/ou1-0-a.pdf ${R}/ou1-1.pdf ${R}/ou1-2.pdf ${R}/ou1-3.pdf
	make ${R}/op1-0-a.pdf ${R}/op1-1.pdf ${R}/op1-2.pdf ${R}/op1-3.pdf
	make ${R}/lu1-0L.pdf ${R}/lu1-1L.pdf ${R}/lp1-0L.pdf ${R}/lp1-1L.pdf ${R}/lp1-8L.pdf
	make ${R}/lp2-0L.pdf ${R}/lp2-1L.pdf ${R}/lp2-8L.pdf
	rm ${R}/*.v ${R}/*.ps

