#============================= generate synthetic land data ==========================

s1loc = $(shell echo $(rec_nz_obs)*1/4 | bc)
s2loc = $(shell echo $(rec_nz_obs)*2/4 | bc)
s3loc = $(shell echo $(rec_nz_obs)*3/4 | bc)

${D}/uxs: ${P}/mod2d_land2.P
	Wavelet n1=${nt} d1=${dt} wavelet=ricker2 phase=0 fund=10 tdelay=0.10 | Pad beg2=${s1loc} n2out=${rec_nz_obs} > ricker1.H
	Wavelet n1=${nt} d1=${dt} wavelet=ricker2 phase=0 fund=10 tdelay=0.20 | Pad beg2=${s2loc} n2out=${rec_nz_obs} > ricker2.H
	Wavelet n1=${nt} d1=${dt} wavelet=ricker2 phase=0 fund=10 tdelay=0.30 | Pad beg2=${s3loc} n2out=${rec_nz_obs} > ricker3.H
	Cat3d ricker1.H ricker2.H ricker3.H axis=3 > ricker.H
	Scale rscale=0 < ricker.H | Noise var=0.00005 > noise.H
	Window3d < ricker.H n3=1 f3=0 > ricker1.H
	Window3d < ricker.H n3=1 f3=1 > ricker2.H
	Window3d < ricker.H n3=1 f3=2 > ricker3.H
	Window3d < noise.H n3=1 f3=0 > noise1.H
	Window3d < noise.H n3=1 f3=1 > noise2.H
	Window3d < noise.H n3=1 f3=2 > noise3.H
	Filter < ricker1.H filter=noise1.H > noise11.H
	Filter < ricker2.H filter=noise2.H > noise22.H
	Filter < ricker3.H filter=noise3.H > noise33.H
	Filter < noise11.H filter=noise1.H | Transp > $@_A.H
	Filter < noise22.H filter=noise2.H | Scale rscale=-2 | Transp > $@_B.H
	Filter < noise33.H filter=noise3.H | Scale rscale=2  | Transp > $@_C.H
	echo "o1=0" >> $@_A.H
	echo "o1=0" >> $@_B.H
	echo "o1=0" >> $@_C.H
	Scale < $@_A.H rscale=1. > ${D}/uzs_A.H
	Scale < $@_B.H rscale=0. > ${D}/uzs_B.H
	Scale < $@_C.H rscale=-1. > ${D}/uzs_C.H
	Rm ricker*.H noise*.H

generate_land_data: ${B}/PS_sep_for.x ${P}/mod2d_land2.P ${D}/recs2d_obs.H ${D}/srcs2d_obs.H
	make ${D}/uxs
	# medium parameters
	Vel n1=${nx} n2=${nz} n3=1 o1=0 o2=0 o3=0 d1=${dx} d2=${dz} d3=1 vc=2000 | Math file1=in exp='1./file1' > ${D}/rho2d_const_for.H
	Vel n1=${nx} n2=${nz} n3=1 o1=0 o2=0 o3=0 d1=${dx} d2=${dz} d3=1 vc=2000 > ${D}/vp2d_const_for.H
	Vel n1=${nx} n2=${nz} n3=1 o1=0 o2=0 o3=0 d1=${dx} d2=${dz} d3=1 vc=1000 > ${D}/vs2d_const_for.H
	Math file1=${D}/rho2d_const_for.H file2=${D}/vs2d_const_for.H exp='file2^2/file1' > ${D}/mu2d_const_for.H
	Math file1=${D}/rho2d_const_for.H file2=${D}/vp2d_const_for.H file3=${D}/mu2d_const_for.H exp='file2^2/file1-2*file3' > ${D}/lambda2d_const_for.H
	# forward modeling
	${B}/PS_sep_for.x lambda=${D}/lambda2d_const_for.H mu=${D}/mu2d_const_for.H rho=${D}/rho2d_const_for.H par=${P}/mod2d_land2.P recs=${D}/recs2d_obs.H srcs=${D}/srcs2d_obs.H \
	proptype=${RCVR} adj=0 splitdisp=0 \
	in_ux_src=${D}/uxs_A.H in_uz_src=${D}/uzs_A.H \
	rec_ux=${D}/uxr_obs_A.H rec_uz=${D}/uzr_obs_A.H \
	rec_P=${D}/Pr_obs_A.H rec_S=${D}/Sr_obs_A.H \
	# medium parameters
	Vel n1=${nx} n2=${nz} n3=1 o1=0 o2=0 o3=0 d1=${dx} d2=${dz} d3=1 vc=1800 | Math file1=in exp='1./file1' > ${D}/rho2d_const_for.H
	Vel n1=${nx} n2=${nz} n3=1 o1=0 o2=0 o3=0 d1=${dx} d2=${dz} d3=1 vc=1800 > ${D}/vp2d_const_for.H
	Vel n1=${nx} n2=${nz} n3=1 o1=0 o2=0 o3=0 d1=${dx} d2=${dz} d3=1 vc=900 > ${D}/vs2d_const_for.H
	Math file1=${D}/rho2d_const_for.H file2=${D}/vs2d_const_for.H exp='file2^2/file1' > ${D}/mu2d_const_for.H
	Math file1=${D}/rho2d_const_for.H file2=${D}/vp2d_const_for.H file3=${D}/mu2d_const_for.H exp='file2^2/file1-2*file3' > ${D}/lambda2d_const_for.H
	# forward modeling
	${B}/PS_sep_for.x lambda=${D}/lambda2d_const_for.H mu=${D}/mu2d_const_for.H rho=${D}/rho2d_const_for.H par=${P}/mod2d_land2.P recs=${D}/recs2d_obs.H srcs=${D}/srcs2d_obs.H \
	proptype=${RCVR} adj=0 splitdisp=0 \
	in_ux_src=${D}/uxs_B.H in_uz_src=${D}/uzs_B.H \
	rec_ux=${D}/uxr_obs_B.H rec_uz=${D}/uzr_obs_B.H \
	rec_P=${D}/Pr_obs_B.H rec_S=${D}/Sr_obs_B.H \
	# medium parameters
	Vel n1=${nx} n2=${nz} n3=1 o1=0 o2=0 o3=0 d1=${dx} d2=${dz} d3=1 vc=1600 | Math file1=in exp='1./file1' > ${D}/rho2d_const_for.H
	Vel n1=${nx} n2=${nz} n3=1 o1=0 o2=0 o3=0 d1=${dx} d2=${dz} d3=1 vc=1600 > ${D}/vp2d_const_for.H
	Vel n1=${nx} n2=${nz} n3=1 o1=0 o2=0 o3=0 d1=${dx} d2=${dz} d3=1 vc=800 > ${D}/vs2d_const_for.H
	Math file1=${D}/rho2d_const_for.H file2=${D}/vs2d_const_for.H exp='file2^2/file1' > ${D}/mu2d_const_for.H
	Math file1=${D}/rho2d_const_for.H file2=${D}/vp2d_const_for.H file3=${D}/mu2d_const_for.H exp='file2^2/file1-2*file3' > ${D}/lambda2d_const_for.H
	# forward modeling
	${B}/PS_sep_for.x lambda=${D}/lambda2d_const_for.H mu=${D}/mu2d_const_for.H rho=${D}/rho2d_const_for.H par=${P}/mod2d_land2.P recs=${D}/recs2d_obs.H srcs=${D}/srcs2d_obs.H \
	proptype=${RCVR} adj=0 splitdisp=0 \
	in_ux_src=${D}/uxs_C.H in_uz_src=${D}/uzs_C.H \
	rec_ux=${D}/uxr_obs_C.H rec_uz=${D}/uzr_obs_C.H \
	rec_P=${D}/Pr_obs_C.H rec_S=${D}/Sr_obs_C.H \
	# combine modeling results to get something that looks like real data
	Add scale=1,1,1 ${D}/uxr_obs_A.H ${D}/uxr_obs_B.H ${D}/uxr_obs_C.H > ${D}/uxr_land2_obs.H
	Add scale=1,1,1 ${D}/uzr_obs_A.H ${D}/uzr_obs_B.H ${D}/uzr_obs_C.H > ${D}/uzr_land2_obs.H
	Add scale=1,1,1 ${D}/Pr_obs_A.H ${D}/Pr_obs_B.H ${D}/Pr_obs_C.H > ${D}/Pr_land2_obs.H
	Add scale=1,1,1 ${D}/Sr_obs_A.H ${D}/Sr_obs_B.H ${D}/Sr_obs_C.H > ${D}/Sr_land2_obs.H
	Reverse < ${D}/Sr_land2_obs.H opt=ignore > ${D}/stmp.H
	Mv ${D}/stmp.H ${D}/Sr_land2_obs.H
	echo "d1=${dz}" >> ${D}/uxr_land2_obs.H
	echo "d1=${dz}" >> ${D}/uzr_land2_obs.H
	echo "d1=${dz}" >> ${D}/Pr_land2_obs.H
	echo "d1=${dz}" >> ${D}/Sr_land2_obs.H
	echo "o1=${oz_mute_land2}" >> ${D}/uxr_land2_obs.H
	echo "o1=${oz_mute_land2}" >> ${D}/uzr_land2_obs.H
	echo "o1=${oz_mute_land2}" >> ${D}/Pr_land2_obs.H
	echo "o1=${oz_mute_land2}" >> ${D}/Sr_land2_obs.H

