#============== MODEL BUILDING ===================================

# receiver locations for generating observed data - read from converted pgm file
#rec_file = ~/local/util/dat/recs.H
#${D}/recs2d_obs.H:  ${B}/create_recs2.x ${rec_file}
#	${B}/create_recs2.x < ${rec_file} > $@

# receiver locations for generating observed data
${D}/recs2d_obs.H:  ${B}/create_recs.x ${P}/mod2d_land2.P
	${B}/create_recs.x >$@ rec_nx=${rec_nx_obs} rec_fx=${rec_fx_obs} rec_jx=${rec_jx_obs} rec_nz=${rec_nz_obs} rec_fz=${rec_fz_obs} rec_jz=${rec_jz_obs}

# source locations for generating observed data
${D}/srcs2d_obs.H:  ${B}/create_recs.x ${P}/mod2d_land2.P
	${B}/create_recs.x >$@ rec_nx=${src_nx_obs} rec_fx=${src_fx_obs} rec_jx=${src_jx_obs} rec_nz=${src_nz_obs} rec_fz=${src_fz_obs} rec_jz=${src_jz_obs}

# receiver locations for silly land data inversion
${D}/recs2d_land2.H:  ${B}/create_recs.x ${P}/mod2d_land2.P
	${B}/create_recs.x >$@ rec_nx=${rec_nx_land2} rec_fx=${rec_fx_land2} rec_jx=${rec_jx_land2} rec_nz=${rec_nz_land2} rec_fz=${rec_fz_land2} rec_jz=${rec_jz_land2}

# source locations for silly land data inversion
${D}/srcs2d_land2.H:  ${B}/create_recs.x ${P}/mod2d_land2.P
	${B}/create_recs.x >$@ rec_nx=${src_nx_land2} rec_fx=${src_fx_land2} rec_jx=${src_jx_land2} rec_nz=${src_nz_land2} rec_fz=${src_fz_land2} rec_jz=${src_jz_land2}

# receiver locations for land data inversion
${D}/recs2d_land.H:  ${B}/create_recs.x ${P}/mod2d_land.P
	${B}/create_recs.x >$@ rec_nx=${rec_nx_land} rec_fx=${rec_fx_land} rec_jx=${rec_jx_land} rec_nz=${rec_nz_land} rec_fz=${rec_fz_land} rec_jz=${rec_jz_land}

# source locations for land data inversion
${D}/srcs2d_land.H:  ${B}/create_recs.x ${P}/mod2d_land.P
	${B}/create_recs.x >$@ rec_nx=${src_nx_land} rec_fx=${src_fx_land} rec_jx=${src_jx_land} rec_nz=${src_nz_land} rec_fz=${src_fz_land} rec_jz=${src_jz_land}

# receiver locations for obn data inversion
${D}/recs2d_obn.H:  ${B}/create_recs.x ${P}/mod2d_obn.P
	${B}/create_recs.x >$@ rec_nx=${rec_nx_obn} rec_fx=${rec_fx_obn} rec_jx=${rec_jx_obn} rec_nz=${rec_nz_obn} rec_fz=${rec_fz_obn} rec_jz=${rec_jz_obn}

# source locations for obn data inversion
${D}/srcs2d_obn.H:  ${B}/create_recs.x ${P}/mod2d_obn.P
	${B}/create_recs.x >$@ rec_nx=${src_nx_obn} rec_fx=${src_fx_obn} rec_jx=${src_jx_obn} rec_nz=${src_nz_obn} rec_fz=${src_fz_obn} rec_jz=${src_jz_obn}

# source locations in ellipse near receivers - read from converted pgm file
#src_file = ~/local/util/dat/ellipse_line.H
#${D}/srcs2d_ellipse.H:  ${B}/create_recs2.x ${src_file}
#	${B}/create_recs2.x < ${src_file} > $@

# velocity and specific volume models

# slow velocity
${D}/rho2d_const_slow.H: 
	Vel n1=${nx} n2=${nz} n3=1 o1=0 o2=0 o3=0 d1=${dx} d2=${dz} d3=1 vc=${rhoc_slow} |\
	Math file1=in exp='1./file1' > $@

${D}/vp2d_const_slow.H:
	Vel n1=${nx} n2=${nz} n3=1 o1=0 o2=0 o3=0 d1=${dx} d2=${dz} d3=1 vc=${vpc_slow} > $@

${D}/vs2d_const_slow.H:
	Vel n1=${nx} n2=${nz} n3=1 o1=0 o2=0 o3=0 d1=${dx} d2=${dz} d3=1 vc=${vsc_slow} > $@

${D}/mu2d_const_slow.H: ${D}/rho2d_const_slow.H ${D}/vs2d_const_slow.H
	Math file1=${D}/rho2d_const_slow.H file2=${D}/vs2d_const_slow.H exp='file2^2/file1' > $@

${D}/lambda2d_const_slow.H: ${D}/rho2d_const_slow.H ${D}/vp2d_const_slow.H ${D}/mu2d_const_slow.H
	Math file1=${D}/rho2d_const_slow.H file2=${D}/vp2d_const_slow.H file3=${D}/mu2d_const_slow.H exp='file2^2/file1-2*file3' > $@

# correct velocity
${D}/rho2d_const.H: 
	Vel n1=${nx} n2=${nz} n3=1 o1=0 o2=0 o3=0 d1=${dx} d2=${dz} d3=1 vc=${rhoc} |\
	Math file1=in exp='1./file1' > $@

${D}/vp2d_const.H:
	Vel n1=${nx} n2=${nz} n3=1 o1=0 o2=0 o3=0 d1=${dx} d2=${dz} d3=1 vc=${vpc} > $@

${D}/vs2d_const.H:
	Vel n1=${nx} n2=${nz} n3=1 o1=0 o2=0 o3=0 d1=${dx} d2=${dz} d3=1 vc=${vsc} > $@

${D}/mu2d_const.H: ${D}/rho2d_const.H ${D}/vs2d_const.H
	Math file1=${D}/rho2d_const.H file2=${D}/vs2d_const.H exp='file2^2/file1' > $@

${D}/lambda2d_const.H: ${D}/rho2d_const.H ${D}/vp2d_const.H ${D}/mu2d_const.H
	Math file1=${D}/rho2d_const.H file2=${D}/vp2d_const.H file3=${D}/mu2d_const.H exp='file2^2/file1-2*file3' > $@

# fast velocity
${D}/rho2d_const_fast.H: 
	Vel n1=${nx} n2=${nz} n3=1 o1=0 o2=0 o3=0 d1=${dx} d2=${dz} d3=1 vc=${rhoc_fast} |\
	Math file1=in exp='1./file1' > $@

${D}/vp2d_const_fast.H:
	Vel n1=${nx} n2=${nz} n3=1 o1=0 o2=0 o3=0 d1=${dx} d2=${dz} d3=1 vc=${vpc_fast} > $@

${D}/vs2d_const_fast.H:
	Vel n1=${nx} n2=${nz} n3=1 o1=0 o2=0 o3=0 d1=${dx} d2=${dz} d3=1 vc=${vsc_fast} > $@

${D}/mu2d_const_fast.H: ${D}/rho2d_const_fast.H ${D}/vs2d_const_fast.H
	Math file1=${D}/rho2d_const_fast.H file2=${D}/vs2d_const_fast.H exp='file2^2/file1' > $@

${D}/lambda2d_const_fast.H: ${D}/rho2d_const_fast.H ${D}/vp2d_const_fast.H ${D}/mu2d_const_fast.H
	Math file1=${D}/rho2d_const_fast.H file2=${D}/vp2d_const_fast.H file3=${D}/mu2d_const_fast.H exp='file2^2/file1-2*file3' > $@


vmodels:
	make ${D}/recs2d_obs.H ${D}/srcs2d_obs.H ${D}/recs2d_land2.H ${D}/srcs2d_land2.H ${D}/recs2d_obn.H ${D}/srcs2d_obn.H ${D}/recs2d_land.H ${D}/srcs2d_land.H
	make ${D}/rho2d_const_slow.H ${D}/vp2d_const_slow.H ${D}/vs2d_const_slow.H ${D}/mu2d_const_slow.H ${D}/lambda2d_const_slow.H
	make ${D}/rho2d_const.H ${D}/vp2d_const.H ${D}/vs2d_const.H ${D}/mu2d_const.H ${D}/lambda2d_const.H
	make ${D}/rho2d_const_fast.H ${D}/vp2d_const_fast.H ${D}/vs2d_const_fast.H ${D}/mu2d_const_fast.H ${D}/lambda2d_const_fast.H



