#============================= DATA PREPROCESSING ==========================

#======== The input data should not contain the direct arrival =======================

f1_rec_land = 0
nt_rec_land = 1700
maxtime_land = 1.4
mintime_land = $(shell echo $(maxtime_land)-$(nt_rec_land)*$(dt) | bc -l)
nt_diff_land = $(shell echo $(nt)-$(nt_rec_land) | bc -l)

VMUTE_LAND = 1650
TMUTE_LAND = 0.45
RSCALE = 1e+13

# get synthetic land data
${D}/Pr_land_obs.H: ${D}/0Pr_land.H
	Transp < $< | Mute vmute=${VMUTE_LAND} tmute=${TMUTE_LAND} | Window3d min1=${mintime_land} max1=${maxtime_land} | Interp d1out=${dt} n1out=${nt_rec_land} maxsize=40 | Transp | Window3d f1=${f1_rec_land} n1=${rec_nz_land} | Pad beg2=${nt_diff_land} | Reverse opt=ignore | Scale rscale=${RSCALE} > $@
	echo "o2=0." >> $@

${D}/Sr_land_obs.H: ${D}/0Sr_land.H
	Transp < $< | Mute vmute=${VMUTE_LAND} tmute=${TMUTE_LAND} | Window3d min1=${mintime_land} max1=${maxtime_land} | Interp d1out=${dt} n1out=${nt_rec_land} maxsize=40 | Transp | Window3d f1=${f1_rec_land} n1=${rec_nz_land} | Pad beg2=${nt_diff_land} | Reverse opt=ignore | Scale rscale=${RSCALE} > $@
	echo "o2=0." >> $@

${D}/uxr_land_obs.H: ${D}/0uxr_land.H
	Transp < $< | Mute vmute=${VMUTE_LAND} tmute=${TMUTE_LAND} | Window3d min1=${mintime_land} max1=${maxtime_land} | Interp d1out=${dt} n1out=${nt_rec_land} maxsize=40 | Transp | Window3d f1=${f1_rec_land} n1=${rec_nz_land} | Pad beg2=${nt_diff_land} | Reverse opt=ignore | Scale rscale=${RSCALE} > $@
	echo "o2=0." >> $@

${D}/uzr_land_obs.H: ${D}/0uzr_land.H
	Transp < $< | Mute vmute=${VMUTE_LAND} tmute=${TMUTE_LAND} | Window3d min1=${mintime_land} max1=${maxtime_land} | Interp d1out=${dt} n1out=${nt_rec_land} maxsize=40 | Transp | Window3d f1=${f1_rec_land} n1=${rec_nz_land} | Pad beg2=${nt_diff_land} | Reverse opt=ignore | Scale rscale=${RSCALE} > $@
	echo "o2=0." >> $@


f1_rec_obn = 200
nt_rec_obn = 1700
maxtime_obn = 1.4
mintime_obn = $(shell echo $(maxtime_obn)-$(nt_rec_obn)*$(dt) | bc -l)
nt_diff_obn = $(shell echo $(nt)-$(nt_rec_obn) | bc -l)

VMUTE_OBN = 1500
TMUTE_OBN = 0.5
RSCALE = 1e+13

# get synthetic obn data
${D}/Pr_obn_obs.H: ${D}/0Pr_obn.H
	Transp < $< | Mute vmute=${VMUTE_OBN} tmute=${TMUTE_OBN} | Window3d min1=${mintime_obn} max1=${maxtime_obn} | Interp d1out=${dt} n1out=${nt_rec_obn} maxsize=40 | Transp | Window3d f1=${f1_rec_obn} n1=${rec_nz_obn} | Pad beg2=${nt_diff_obn} | Reverse opt=ignore | Scale rscale=${RSCALE} > $@
	echo "o2=0." >> $@

${D}/Sr_obn_obs.H: ${D}/0Sr_obn.H
	Transp < $< | Mute vmute=${VMUTE_OBN} tmute=${TMUTE_OBN} | Window3d min1=${mintime_obn} max1=${maxtime_obn} | Interp d1out=${dt} n1out=${nt_rec_obn} maxsize=40 | Transp | Window3d f1=${f1_rec_obn} n1=${rec_nz_obn} | Pad beg2=${nt_diff_obn} | Reverse opt=ignore | Scale rscale=${RSCALE} > $@
	echo "o2=0." >> $@

${D}/uxr_obn_obs.H: ${D}/0uxr_obn.H
	Transp < $< | Mute vmute=${VMUTE_OBN} tmute=${TMUTE_OBN} | Window3d min1=${mintime_obn} max1=${maxtime_obn} | Interp d1out=${dt} n1out=${nt_rec_obn} maxsize=40 | Transp | Window3d f1=${f1_rec_obn} n1=${rec_nz_obn} | Pad beg2=${nt_diff_obn} | Reverse opt=ignore | Scale rscale=${RSCALE} > $@
	echo "o2=0." >> $@

${D}/uzr_obn_obs.H: ${D}/0uzr_obn.H
	Transp < $< | Mute vmute=${VMUTE_OBN} tmute=${TMUTE_OBN} | Window3d min1=${mintime_obn} max1=${maxtime_obn} | Interp d1out=${dt} n1out=${nt_rec_obn} maxsize=40 | Transp | Window3d f1=${f1_rec_obn} n1=${rec_nz_obn} | Pad beg2=${nt_diff_obn} | Reverse opt=ignore | Scale rscale=${RSCALE} > $@
	echo "o2=0." >> $@

inputs:
	make ${D}/Pr_land_obs.H ${D}/Sr_land_obs.H ${D}/uxr_land_obs.H ${D}/uzr_land_obs.H
	make ${D}/Pr_obn_obs.H ${D}/Sr_obn_obs.H ${D}/uxr_obn_obs.H ${D}/uzr_obn_obs.H
