program elas2d
	use sep
	use elas2d_thread_mod
	use elas2d_model_mod
	use elas2d_distrib_mod
	use elas2d_io_mod

	implicit none

	integer						:: it,i
	type (thread_type)			:: thread_s
	type (model_type)			:: model_s
	type (distrib_type), pointer	:: distrib_s(:), my_distrib
	type (io_type)				:: io_s
	integer,external			:: omp_get_thread_num, omp_get_num_threads
	logical						:: logic


	call sep_init (SOURCE)


	!read model parameters
	write (0,*) "MODEL INIT"
	call model_init (model_s, "lambda")


	!distribion
	!read in thread information
	write (0,*) "THREAD INIT"
	call thread_init (thread_s)
	allocate (distrib_s (thread_s%nth))
	write (0,*) "DISTRIB INIT"
	call distrib_init (thread_s, model_s, distrib_s)


	!output init
	write (0,*) "IO INIT"
	call io_init (model_s, io_s)
	!allocate,read, and distribute

	write (0,*) "CREATE ARRAYS"
	call create_arrays (distrib_s,model_s)
	

	write (0,*) "SET TIMERS"
	logic = init_sep_timers  ()
	logic = setup_next_timer ("V4",tm_v4)
	logic = setup_next_timer ("U4",tm_u4)
	logic = setup_next_timer ("Disp",tm_se)
	logic = setup_next_timer ("DispSpace",tm_space)
	logic = setup_next_timer ("Sponge",tm_sp)
	logic = setup_next_timer ("Tau",tm_tau)
	logic = setup_next_timer ("Write",tm_write)

	write (0,*) "SET OMP THREAD"
	thread_s%ith = omp_get_thread_num() + 1
	i = thread_s%ith
	my_distrib => distrib_s (thread_s%ith)

	!initialize thread specific stuff
	call fdvsg3d_vg_coeffx (my_distrib)
	call fdvsg3d_vg_coeffz (my_distrib)


	write (0,*) "TIME LOOP"
	!loop of time
	do it = 1, model_s%nt
		!advance one step    
		if ( mod (it,100) == 0) write (0,*) "TIMESTEP", it*model_s%dt

		call one_step (thread_s%ith, it, model_s, distrib_s, io_s)

		!write out files
		call start_timer_num (tm_write)
		call write_out_files (it, thread_s, model_s, distrib_s, io_s)
		call stop_timer_num  (tm_write)

	end do
	call print_timers()

end program
