program ps_sep_for
	use sep
	use distrib_type_mod
	use model_mod
	use io_mod

	implicit none

	integer						:: mystat
	type (model_type)			:: model_s
	type (distrib_type)			:: distrib_s
	type (io_type)				:: io_s_main
	integer, external			:: omp_get_thread_num, omp_get_num_threads
	logical						:: logic
	


	call sep_init (SOURCE)


	!read model parameters
	write (0,*) "MODEL INIT"
	call model_init (model_s, "lambda")

	!output init
	write (0,*) "IO INIT"
	call io_init (model_s, io_s_main)

	!allocate,read, and distribute
	write (0,*) "CREATE ARRAYS"
	call create_arrays (distrib_s, model_s)
	

	!stupid global variable init
	write (0,*) "STUPID GLOBAL VARIABLE INIT"
	call global_init (model_s, distrib_s, io_s_main)

	! read receiver data
	call load_srcs ("in_ux_src", io_s_main%in_ux_src, model_s, distrib_s, uxs_i)
	call load_srcs ("in_uz_src", io_s_main%in_uz_src, model_s, distrib_s, uzs_i)

	write (0,*) "SET TIMERS"
	logic = init_sep_timers  ()
	logic = setup_next_timer ("V4",tm_v4)
	logic = setup_next_timer ("U4",tm_u4)
	logic = setup_next_timer ("Disp",tm_se)
	logic = setup_next_timer ("DispSpace",tm_space)
	logic = setup_next_timer ("Sponge",tm_sp)
	logic = setup_next_timer ("Write",tm_write)
	logic = setup_next_timer ("Read",tm_read)
	logic = setup_next_timer ("CGstep",tm_cgstep)

	! Run the forward operator
	write (0,*) "FORWARD TIME LOOP"
	mystat = L_oper (.false., .false., distrib_s%srcmodel, distrib_s%recdata)

	! write receiver data
	call save_recs ("rec_ux", io_s_main%rec_ux, model_s, distrib_s, uxr_i)
	call save_recs ("rec_uz", io_s_main%rec_uz, model_s, distrib_s, uzr_i)
	call save_recs ("rec_P", io_s_main%rec_P, model_s, distrib_s, Pr_i)

	call print_timers()

end program
