module distrib_type_mod
	integer,parameter :: P_i=1, S_i=2
	integer,parameter :: uxm_i=3, uxo_i=4, uxp_i=5
	integer,parameter :: uzm_i=6, uzo_i=7, uzp_i=8
	integer,parameter :: vxo_i=9, vzo_i=10
	integer,parameter :: Upx_i=11, Upz_i=12, Usx_i=13, Usz_i=14
	integer,parameter :: uxs_i=0, uzs_i=1
	integer,parameter :: uxr_i=0, uzr_i=1, Pr_i=2


type distrib_type

	real,pointer :: sponge_x(:)	! sponge in x
	real,pointer :: sponge_z(:)	! sponge in z

	real,pointer :: rho(:,:)	! smooth density
	real,pointer :: lambda(:,:)	! smooth lambda
	real,pointer :: mu(:,:)		! smooth mu

	real,pointer :: P (:,:)		! Pressure wave
	real,pointer :: S (:,:)		! Shear wave
	real,pointer :: uxm(:,:)	! displacement in x
	real,pointer :: uxo(:,:)
	real,pointer :: uxp(:,:)
	real,pointer :: uzm(:,:)	! displacement in z
	real,pointer :: uzo(:,:)
	real,pointer :: uzp(:,:)
	real,pointer :: vxo(:,:)	! particle velocity in x
	real,pointer :: vzo(:,:)	! particle velocity in x
	real,pointer :: Upx(:,:)	! P-wave displacement in x
	real,pointer :: Upz(:,:)	! P-wave displacement in z
	real,pointer :: Usx(:,:)	! S-wave displacement in x
	real,pointer :: Usz(:,:)	! S-wave displacement in z
	real,pointer  ::  all(:,:,:) !all of the wavefield arrays

	real,pointer :: uxs (:)			! virtual displacement source in x
	real,pointer :: uzs (:)			! virtual displacement source in z
	real,pointer :: srcmodel (:)	! all virtual source models
	real,pointer :: uxr (:)			! geophone recording x
	real,pointer :: uzr (:)			! geophone recording z
	real,pointer :: Pr  (:)			! hydrophone recording
	real,pointer :: recdata (:)		! all receiver data
end type

end module


