module model_type_mod
	use helicon
	implicit none

integer,parameter :: source=0, receiver=1

type model_type
	logical			:: adj, add
	integer			:: nx,nz		!grid size in x,y, and z
	integer			:: fx,fz		!first index - some distribution leftover from the MPI version. I moved it from the distrib_type to the model_type.
	real			:: dx,dz		!sampling in x,y, and z
	integer			:: nt			!number of time samples
	real			:: dt			!sampling in time
	integer,pointer	:: recs(:,:)	!receiver locations
	integer,pointer	:: srcs(:,:)	!virtual source locations
	real			:: fpeak		!peak frequency
	real,pointer	:: wavelet(:)	!wavelet   
	integer			:: isrc_type	!type of src
	integer			:: izsrc,ixsrc	!point source location
	real,pointer	:: sponge_x(:), sponge_z(:)	!damping coefficients
	integer			:: nsponge_x,nsponge_z		!sponge zone size (one side)
	integer			:: proptype		!source or receiver wavefield
	integer			:: splitdisp	! do the displacement decomposition?
	type (filter)	:: dfilt		! helical filter coefficients
	real			:: decon_norm	! normalization coefficient frhor helical deconvolution
end type

end module

